
class PBall extends PObject
{
  int maxV = 15 ;
  int minV = 6 ;
  int sVel ;    
  boolean limX = true ;
  boolean limY = true ;
  PSound sound ;

  PBall ( int _size, boolean _limX, boolean _limY, int _maxV, int _minV ) {
    super ( _size, _size, width / 2, height / 2, _maxV ) ;
    minY  = bord ;
    maxY  = height - _size - bord ;
    minX  = 0 ;
    maxX  = width  ;    
    maxV  = _maxV ;
    minV  = _minV ;
    limX  = _limX ;
    limY  = _limY ;
    sound = new PSound () ;
  }
      
  void kickOff () {   
    setPosition ( new PVector ( width / 2 , height / 2 )) ;
    sVel = int ( random (( maxV - minV ))) + minV ; 
    sound.playSound ( "pip.ogg" ) ;    
    setVelocity ( new PVector ( sVel * ( Math.round(Math.random()) * 2 - 1 ),
                                sVel * ( Math.round(Math.random()) * 2 - 1 ))) ;   
  }
  
  void outOfBounds () {
    sound.playSound ( "pip.ogg" ) ; 
  }
  
  void checkOutOfBounds () {
    if ( limY == true ) {
      if ((( int ( pos.y ) + int ( vel.y )) < minY ) || 
        (( int ( pos.y ) + int ( vel.y )) > maxY )) {
         rebY () ; 
      }
    }
    if ( limX == true ) {
      if ((( int ( pos.x ) + int ( vel.x )) < minX ) ||
        (( int ( pos.x ) + int ( vel.x )) > maxX )) {
         rebX () ;
      }
    }
  }
  
  void rebX () {
    super.rebX () ;
    sound.playSound ( "pop.ogg" ) ;        
  }
  
  void rebY () {
    super.rebY () ;
    sound.playSound ( "pop.ogg" ) ;        
  }
  
  void update () {
    checkOutOfBounds () ;
    super.update () ;
  }  
}
