class PObject
{
  int bord = 10 ;
  int pWidth ;
  int pHeight ;
  PVector pos ;
  PVector oldPos ;
  PVector vel ;
  int maxVel = 80 ;
  int maxY ;
  int minY ; 
  int maxX ;
  int minX ;
  
  PObject ( int _width, int _height, int _X, int _Y, int _maxVel ) {
    pWidth = _width ;
    pHeight = _height ;
    maxVel = _maxVel ;
    pos = new PVector ( float ( _X ), float ( _Y )) ;
    oldPos = pos ;
    vel = new PVector ( 0, 0 ) ;
    rect ( int ( pos.x ), int ( pos.y ), pWidth, pHeight ) ; 
    minY = 0 ;
    minX = 0 ;
    maxX = width ;
    maxY = height ;
  }
  
  PVector getPosition () {
    return pos.get () ;
  }
  
  PVector getVelocity () {
    return vel.get () ;
  }
  
  void setPosition ( PVector _nPos ) {
    pos = _nPos.get () ;
  }
  
  void setVelocity ( PVector _nVel ) {
    vel = _nVel.get () ;
  }

  void rebX () {
    vel.x = - vel.x ;
  }
  
  void rebY () {
    vel.y = - vel.y ;
  }
  
  int getX () {
    return int ( pos.x ) ;
  }
  
  int getY () {
    return int ( pos.y ) ;
  }
  
  int getWidth () {
    return pWidth ;
  }
  
  int getHeight () {
    return pHeight  ;
  }
  
 int hitObject ( PObject obj ) {
    return ( hitArea ( obj.getX  (), obj.getY (), 
                       obj.getWidth (), obj.getHeight())) ;
  }
  
  int hitArea ( int _x, int _y, int _width, int _height ) {
    return ( Math.max ( 0,   Math.min ( int ( pos.x ) + pWidth, _x + _width ) 
                           - Math.max ( int ( pos.x ), _x )) *                           
             Math.max ( 0,   Math.min ( int ( pos.y ) + pHeight, _y + _height ) 
                           - Math.max ( int ( pos.y ), _y ))) ;                        
  }
  
  void update ()  {
    oldPos = pos.get () ;
    pos.add ( vel ) ;
  }
  
  void incVel ( PVector _uVel ) {
    vel.add ( _uVel ) ;
    vel.limit ( maxVel ) ;
  }
  
  void display () {
     fill ( color ( 255, 64 )) ;
     rect ( oldPos.x, oldPos.y, pWidth, pHeight ) ;
     fill ( 255 ) ;
     rect ( pos.x, pos.y, pWidth, pHeight ) ; 
  }
}
