
class PStick extends PObject 
{
  int force     = 5 ;
  int loss      = 0 ;
  int incSpeed  = 1 ;
  int threshold = 20 ;
  
  PStick ( int _width, int _height, int _X, int _Y, int _incVel, int _maxVel ) {
    super ( _width, _height, _X, _Y, _maxVel ) ;
    minY     = 0 ;
    maxY     = height - _height  ;
    incSpeed = _incVel ;
  }
  
  void update () {
    if ((( int ( pos.y ) + int ( vel.y )) > maxY ) || 
        (( int ( pos.y ) + int ( vel.y )) < minY )) {
      setVelocity ( new PVector ( 0, 0 )) ;
    }
    super.update () ;
  }
  
  void hit ( PObject object ) {
    float incV = vel.y ;   
    float forceH = force ;
    incV = ( abs ( incV ) > forceH ) ? ( incV / abs ( incV )) * forceH : incV ;
    object.incVel ( new PVector ( 0, incV )) ;
    object.rebX () ;
  }
  
  void goUp () {
    setVelocity ( new PVector ( 0, - maxVel )) ;
  }
  
  void goDown () {
    setVelocity ( new PVector ( 0, maxVel )) ;    
  }

  void follow ( PObject object ) {
    if (( object.getY () - threshold - maxVel ) > pos.y ) {
      goDown () ;
    }
    else {
      if (( object.getY () + threshold + maxVel ) < pos.y ) {
        goUp () ;
      }
    }
  }
}

